/*  legendre_10.c */

/*
	Legendre¿༰ˤwavեκ
	P[10,x] = -(63/256) + (3465/256)x^2 - (15015/128)x^4
            - (45045/128)x^6 - (109395/256)x^8 + (46189/256)x^10 

	16bit	ƥ쥪  ץǡ
*/

#include	<stdio.h>
#include	<math.h>

typedef	struct	tagWaveHeaderType	{
  char	cRiffHeader[4];
  long	nFileSize;
  char	cWaveHeader[4];
  char	cFmtChunk[4];
  long	nChunkSize;
  short	nFmtID;
  short	nCh;
  long	nRate;
  long	nSpeed;
  short	nBlockSize;
  short	nBitsParSample;
  char	cDataChunk[4];
  long	nDataBytes;
}	WaveHeaderType, * LpWaveHeaderType;


void	InitHeader( LpWaveHeaderType p )
{
  p->cRiffHeader[0] = 'R';
  p->cRiffHeader[1] = 'I';
  p->cRiffHeader[2] = 'F';
  p->cRiffHeader[3] = 'F';
	
  p->nFileSize = 0;	/*	ե륵ʸǷ׻	*/
	
  p->cWaveHeader[0] = 'W';
  p->cWaveHeader[1] = 'A';
  p->cWaveHeader[2] = 'V';
  p->cWaveHeader[3] = 'E';
	
  p->cFmtChunk[0] = 'f';
  p->cFmtChunk[1] = 'm';
  p->cFmtChunk[2] = 't';
  p->cFmtChunk[3] = ' ';
	
  p->nChunkSize = 16;
	
  p->nFmtID = 1;	/*	˥PCMʲϿ	*/
	
  p->nCh = 2;		/*	ƥ쥪	*/
  p->nRate = 44100;	/*	ץ󥰼ȿ
						ñ̻Υǡκμ	*/
  p->nSpeed = 176400;	/*	ʿѥǡ®	*/
  p->nBlockSize = 4;	/*	֥å	*/
  p->nBitsParSample = 16;	/*	̻Ҳӥåȿ	*/
	
  p->cDataChunk[0] = 'd';
  p->cDataChunk[1] = 'a';
  p->cDataChunk[2] = 't';
  p->cDataChunk[3] = 'a';
       
  p->nDataBytes = 176400L*8L;	/*	ǡ	*/
	
  p->nFileSize = p->nDataBytes + 44L - 8L;	/*	ե륵	*/
}

unsigned char legendre( int i, double a, int n );


int		main()
{
  WaveHeaderType	h;
  int		i;
  char	c;
  FILE*	fp;

  int n1 = 0;    /* legendre¿༰˴ޤޤμ */
  int n2 = 2;
  int n3 = 4; 
  int n4 = 6;
  int n5 = 8;
  int n6 = 10;

  double a1 = -0.2460938;     /* legendre¿༰η*/
  double a2 = 13.535156;
  double a3 = -117.30469;
  double a4 = 351.91406;
  double a5 = -427.32422;
  double a6 = 180.42578;

  fp = fopen( "legendre_10.wav", "wb" );
	
  InitHeader( &h );
	
  fwrite( &h, sizeof(h), 1, fp );
	

  /* 8 */
  for( i = 0; i < 176400*1; i++ ) {
	c = legendre( i, a1, n1);
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*1; i < 176400*2; i++ ){
	c = legendre( i, a1, n1 )
	  + legendre( i, a2, n2 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*2; i < 176400*3; i++ ){
	c = legendre( i, a1, n1 ) 
	  + legendre( i, a2, n2 ) 
	  + legendre( i, a3, n3 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*3; i < 176400*4; i++ ){
	c = legendre( i, a1, n1 )
	  + legendre( i, a2, n2 )
	  + legendre( i, a3, n3 ) 
	  + legendre( i, a4, n4 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*4; i < 176400*5; i++ ){
	c = legendre( i, a1, n1 ) 
	  + legendre( i, a2, n2 ) 
	  + legendre( i, a3, n3 )
	  + legendre( i, a4, n4 ) 
	  + legendre( i, a5, n5 );
	fwrite( &c, sizeof(c), 1, fp );	
  }


  for (i = 176400*5; i < 176400*8; i++ ){
	c = legendre( i, a1, n1 )
	  + legendre( i, a2, n2 ) 
	  + legendre( i, a3, n3 ) 
	  + legendre( i, a4, n4 ) 
	  + legendre( i, a5, n5 ) 
	  + legendre( i, a6, n6 );
	fwrite( &c, sizeof(c), 1, fp );	
  }


  fclose( fp );

  return 0 ;
}

unsigned char legendre( int i, double a, int n)
{
  unsigned char f = 0;
  int v = 700;           /* Ȥ®١Ŭ */
    

  f = 0.05 * ( a * sin( n * (double)(i / 176400.0) * v )
			   + a * cos( n * (double)(i / 176400.0) * v ));

  return f;
}


/* legendre_10.c  end */
