/*  legendre_9.c */

/*
  Legendre¿༰ˤwavեκ
  P[9,x] = -(315/28)x - (1155/32)x^3 - (9009/64)x^5 
         + (6435/32)x^7 + (12155/128)x^9

  16bit	ƥ쥪  ץǡ
*/

#include	<stdio.h>
#include	<math.h>

typedef	struct	tagWaveHeaderType	{
  char	cRiffHeader[4];
  long	nFileSize;
  char	cWaveHeader[4];
  char	cFmtChunk[4];
  long	nChunkSize;
  short	nFmtID;
  short	nCh;
  long	nRate;
  long	nSpeed;
  short	nBlockSize;
  short	nBitsParSample;
  char	cDataChunk[4];
  long	nDataBytes;
}	WaveHeaderType, * LpWaveHeaderType;


void	InitHeader( LpWaveHeaderType p )
{
  p->cRiffHeader[0] = 'R';
  p->cRiffHeader[1] = 'I';
  p->cRiffHeader[2] = 'F';
  p->cRiffHeader[3] = 'F';
	
  p->nFileSize = 0;	/*	ե륵ʸǷ׻	*/
	
  p->cWaveHeader[0] = 'W';
  p->cWaveHeader[1] = 'A';
  p->cWaveHeader[2] = 'V';
  p->cWaveHeader[3] = 'E';
	
  p->cFmtChunk[0] = 'f';
  p->cFmtChunk[1] = 'm';
  p->cFmtChunk[2] = 't';
  p->cFmtChunk[3] = ' ';
	
  p->nChunkSize = 16;
	
  p->nFmtID = 1;	/*	˥PCMʲϿ	*/
	
  p->nCh = 2;		/*	ƥ쥪	*/
  p->nRate = 44100;	/*	ץ󥰼ȿ
						ñ̻Υǡκμ	*/
  p->nSpeed = 176400;	/*	ʿѥǡ®	*/
  p->nBlockSize = 4;	/*	֥å	*/
  p->nBitsParSample = 16;	/*	̻Ҳӥåȿ	*/
	
  p->cDataChunk[0] = 'd';
  p->cDataChunk[1] = 'a';
  p->cDataChunk[2] = 't';
  p->cDataChunk[3] = 'a';
       
  p->nDataBytes = 176400L*7L;	/*	ǡ	*/
	
  p->nFileSize = p->nDataBytes + 44L - 8L;	/*	ե륵	*/
}

unsigned char legendre( int i, double a, int n );


int		main()
{
  WaveHeaderType	h;
  int		i;
  char	c;
  FILE*	fp;

  int n1 = 1;    /* legendre¿༰˴ޤޤμ */
  int n2 = 3;
  int n3 = 5;
  int n4 = 7;
  int n5 = 9;

  double a1 = 2.4609375;     /* legendre¿༰η*/
  double a2 = -36.09375;
  double a3 = 140.76563;
  double a4 = -201.09375;
  double a5 = 94.960938;

  fp = fopen( "legendre_9.wav", "wb" );
	
  InitHeader( &h );
	
  fwrite( &h, sizeof(h), 1, fp );
	

  /* 7 */
  for( i = 0; i < 176400*1; i++ ) {
	c = legendre( i, a1, n1);
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*1; i < 176400*2; i++ ){
	c = legendre( i, a1, n1 )
	  + legendre( i, a2, n2 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*2; i < 176400*3; i++ ){
	c = legendre( i, a1, n1 )
	  + legendre( i, a2, n2 ) 
	  + legendre( i, a3, n3 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*3; i < 176400*4; i++ ){
	c = legendre( i, a1, n1 ) 
	  + legendre( i, a2, n2 ) 
	  + legendre( i, a3, n3 ) 
	  + legendre( i, a4, n4 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*4; i < 176400*7; i++ ){
	c = legendre( i, a1, n1 ) 
	  + legendre( i, a2, n2 ) 
	  + legendre( i, a3, n3 ) 
	  + legendre( i, a4, n4 ) 
	  + legendre( i, a5, n5 );
	fwrite( &c, sizeof(c), 1, fp );	
  }


  fclose( fp );

  return 0 ;
}

unsigned char legendre( int i, double a, int n)
{
  unsigned char f = 0;
  int v = 700;           /* Ȥ®١Ŭ */
    

  f = 0.2 * (a * sin( n * (double)(i / 176400.0) * v ) 
			 + a * cos( n * (double)(i / 176400.0) * v ));

  return f;
}


/* legendre_9.c  end */
